module LANGScript
  MAJOR = 0x01
  MINOR = 0x01

  TAG_BEGIN = [0xC2,140].pack('C*')
  TAG_NAME  = [0xC2,150].pack('C*')
  TAG_TEXT  = [0xC2,160].pack('C*')
  TAG_LINE  = [0xC2,170].pack('C*')
  LNG_BEGIN = [0xC2,180].pack('C*')
  LNG_TAGS  = [0xC2,190].pack('C*')
  LNG_END   = [0xC3,136].pack('C*')

  #----------------------------------------------------------------------------
  # * Carregamento dos arquivos de linguagem
  #----------------------------------------------------------------------------
  def load_files
    Dir.entries(FOLDER).each do |entry|
      next unless FileTest.file?(FOLDER + '/' + entry)
      txt   = File.open(FOLDER + '/' + entry, 'rb') {|f| f.read}
      major = txt[0].unpack('U').first
      minor = txt[1].unpack('U').first

      if major > MAJOR || (major >= MAJOR && minor > MINOR)
        puts "LANG Script version not compatible"
        return ''
      end

      enc   = txt[2].unpack('U').first > 1
      txt   = txt[3..-1]
      txt.split(LNG_END).each do |l|
        langname = enc ? decrypt(l[LNG_BEGIN.size...l.index(LNG_TAGS)]) : l[LNG_BEGIN.size...l.index(LNG_TAGS)]
        unless l[0...LNG_BEGIN.size] == LNG_BEGIN
          puts "Invalid language file"
          return ''
        end
        l[(l.index(LNG_TAGS) + LNG_TAGS.size)..-1].split("\n").each do |t|
          unless t[0...TAG_BEGIN.size] == TAG_BEGIN
            puts "Invalid language file"
            return ''
          end
          unless t[TAG_BEGIN.size..(TAG_NAME.size+1)] == TAG_NAME
            puts "Invalid language file"
            return ''
          end
          i = t.index(TAG_TEXT)
          unless i
            puts "Invalid language file"
            return ''
          end
          name = enc ? decrypt(t[(TAG_BEGIN.size + TAG_NAME.size)...i]) : t[(TAG_BEGIN.size + TAG_NAME.size)...i].force_encoding('UTF-8')
          text = enc ? decrypt(t[(i+TAG_TEXT.size)...t.size]) : t[(i+TAG_TEXT.size)...t.size].force_encoding('UTF-8')
          begin
            LANGUAGES[langname] ||= {}
            LANGUAGES[langname][name] = text.gsub(TAG_LINE.force_encoding('UTF-8'), "\n")
          rescue
            puts "Invalid language file"
            return ''
          end
        end
      end
    end
  end

  #----------------------------------------------------------------------------
  # * Carregamento de uma string
  #----------------------------------------------------------------------------
  def load(tag, lang)
    load_files unless LANGUAGES.keys.include? lang
    if LANGUAGES[lang]
      if LANGUAGES[lang][tag]
        return LANGUAGES[lang][tag]
      else
        puts "Failed to load tag '#{tag}': Could not find tag"
      end
    else
      puts "Failed to load tag '#{tag}': Could not find language"
    end
    return ''
  end
end
